#!/bin/sh -x

set -e

PND=updater.pnd

if [ $USER != notaz ]
then
	echo "you are not notaz"
	exit 1
fi

rm -rf out $PND
mkdir out
mkdir out/feeds/
mkdir out/feeds/armv7a/
mkdir out/feeds/omap3-pandora/
mkdir out/feeds/all/

cd out
# tar xvf $HOME/oe_rootfs_extra.tar.bz2
cp ../in/* .
cp ../../oe_make_bootf/autoboot.txt .

tpath=`pwd`

cd $HOME/oe/tmp/angstrom.5/deploy/glibc/ipk/
find . -name '*.ipk' \
     -newer $tpath/../tools/ref.ipk \! -name '*-dev_*' \! -name '*-dbg_*' \
     \! -name '*-doc_*' \! -name '*-static_*' \! -name 'libgles-omap3-*' \
     -exec cp -a {} $tpath/feeds/{} \;

cd $tpath
set +x

# clean unneeded ipks that are not in latest installed-packages.txt
listf=`find $HOME/oe/tmp/angstrom.5/deploy/glibc/images/omap3-pandora/ \
	-name installed-packages.txt | grep -v nowifi | sort | tail -n 1`
for f in feeds/armv7a/* feeds/omap3-pandora/* feeds/all/*; do
	b=`basename $f`
	bb=`echo $b | awk -F- '{print $1}'`
	if ! grep -q "\<$bb\>" $listf; then
		rm -f $f
	fi
done

set -x
cd $HOME/oe/tmp/angstrom.5/deploy/glibc/ipk/

find . -name 'Packages*' -exec cp -a {} $tpath/feeds/{} \;
cd $tpath

../tools/pnd_make.sh -p ../$PND -d . -x PXML.xml -i updater.png -c
