#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <unistd.h>

int main(int argc, char *argv[])
{
	volatile unsigned int *regs;
	unsigned int nreg, val;
	int memdev;
	char *p;

	if (argc < 2)
	{
		printf("%s <reg> [val]\n", argv[0]);
		return 1;
	}

	nreg = strtoul(argv[1], &p, 0);
	if (*p != 0)
	{
		printf("bad arg 1\n");
		return 1;
	}

	memdev = open("/dev/mem", O_RDWR|O_SYNC);
	if (memdev == -1)
	{
		perror("open /dev/mem");
		return 1;
	}

  	regs = mmap(0, 0x1000, PROT_WRITE|PROT_READ, MAP_SHARED, memdev, nreg & ~0xfff);
	if (regs == MAP_FAILED)
	{
		close(memdev);
		perror("mmap");
		return 1;
	}

	printf(" = 0x%08x\n", regs[(nreg&0xfff)>>2]);

	if (argc == 3)
	{
		val = strtoul(argv[2], &p, 0);
		if (*p != 0)
		{
			printf("bad arg 2\n");
			return 1;
		}

		regs[(nreg&0xfff)>>2] = val;
		printf("val set.\n");
	}

	munmap((void *)regs, 0x1000);
	close(memdev);

	return 0;
}

